#include "colors"
#include "textures"



/*{{{ camera, llum, fons */

light_source { <-25000,100,2000>, 1.5}

light_source { <0,5000,2000>, 1.5}

camera {
  location  <-10, 10 , 45>
  right -4/3*x
  angle 9 
  look_at   < 1.5,0,0>
}
background{rgb .02}

 plane { <0, 1, 0>, -0.5     // normal, displacement
    pigment {
      checker color White, color Gray
    }
  }

/*{{{ Pla inclinat inexistent */
/*
#declare Spla = sin(45*pi/180);
#declare Cpla = cos(45*pi/180);

 plane { <-Spla, Cpla, 0>, -4.0     // normal, displacement
    pigment {
      checker color Red  , color Yellow
    }
  }
*/
/*}}}*/

/*}}}*/

/*{{{ Definicio de sistema de referencia*/
#declare SRef=

   union{
         cylinder{<0, 0, 0>, <1.50, 0, 0>, .025 texture { pigment { color Red   } } }
   //    cylinder{<0, 0, 0>, <0, 1.40, 0>, .025 texture { pigment { color Green } } }
         cylinder{<0, 0, 0>, <0, 0, 1.50>, .025 texture { pigment { color Blue  } } }
        }
        
/*}}}*/


/*{{{ Lectura Taula Denavit-Hartenberg: */

//      alfa    a    |     d    fi      // 

#fopen Dades "taula-DH" read

//  #while (defined(Dades))

#read (Dades, Alfa0, A0, D1, Fi1)
#read (Dades, Alfa1, A1, D2, Fi2)
#read (Dades, Alfa2, A2, D3, Fi3)



/*}}}*/



/*{{{ Definicio de l'element 0 */

#declare Gruix=0.08;

#declare Element0= 

   union{
         cylinder{  <  0, -1, 0>, <0, 0, 0>, Gruix texture { Copper_Metal } }
        }
        
/*}}}*/
/*{{{ Definicio de l'element 1 */

#declare Element1= 

   union{
         cylinder{  <  0, 0, 0>, <2.0, 0, 0>, Gruix texture { Copper_Metal } }

         cylinder{  <0, 0, -0.5>,   <0, 0, 0.5>, 1.2*Gruix texture { Copper_Metal } }
        }
        
/*}}}*/
/*{{{ Definicio de l'element 2 */

#declare Element2= 

   union{
         cylinder{  <  0, 0, 0>, <2.0, 0, 0>, Gruix texture { Copper_Metal } }

         cylinder{<0, 0, -Gruix>, <0, 0, Gruix>, 1.2*Gruix  texture { Copper_Metal } }
        }
        
/*}}}*/
/*{{{ Definicio de l'element 3 */

#declare Element3= 

   union{

         cylinder{ <  0, 0, 0>, <1.5, 0, 0>, Gruix  }
         cone    { < 1.5, 0, 0 >   , Gruix    // Center and radius of one end
                  <  1.5+0.75*Gruix,0,0> , 0  // Center and radius of other end
                 }                
         cylinder{<0, 0, -Gruix>, <0, 0, Gruix>, 1.2*Gruix }
         texture { Copper_Metal }

        }
        
/*}}}*/

/*{{{ Calculs posicio */

// Aquesta part es a tall d'exemple !
// Aqui heu de solucionar el problema cinematic invers.
// L'escriptura de resultats intermitjos via el fitxer
// calculs  us permetra fer un minim debugging en cas
// de necessitat
	
// Teniu informacio addicional sobre construccions matematiques
// en els fitxers how_to_*.txt


#fopen Calculs "calculs" write


#declare L1 = 2.0;
#declare L2 = 2.0;
#declare L3 = 1.56;

#declare B = 0.5;                // alada de la base


#declare Gamma = 30 * pi / 180;  // Inclinacio del darrer element

#declare Cgamma = cos(Gamma);
#declare Sgamma = sin(Gamma);

#declare X = 4.5;               //  Punt de contacte de l'extrem
#declare Y = 0;                 //  Punt de contacte de l'extrem

#declare X = X - L3 * Sgamma;        // braos 1 i 2

#write (Calculs, X, "," , Y, "\n")

#declare R = sqrt ( X*X + Y*Y ) ;
#declare Beta = atan2 ( Y, X )  ;

#write (Calculs, R, "," , Beta, "\n")

/*}}}*/

/*{{{ Escena */
// Escena 

// Base:
object {SRef}

object { Element0 }



// Sistema 1:

object { SRef 

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }

object { Element1

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }

// Sistema 2:

object { SRef 
           rotate      Fi2*z
           translate    D2*z
           rotate    Alfa1*x
           translate    A1*x

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }


object { Element2
           rotate      Fi2*z
           translate    D2*z
           rotate    Alfa1*x
           translate    A1*x

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }

// Sistema 3:

object { SRef  
           rotate      Fi3*z
           translate    D3*z
           rotate    Alfa2*x
           translate    A2*x

           rotate      Fi2*z
           translate    D2*z
           rotate    Alfa1*x
           translate    A1*x

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }


object { Element3
           rotate      Fi3*z
           translate    D3*z
           rotate    Alfa2*x
           translate    A2*x

           rotate      Fi2*z
           translate    D2*z
           rotate    Alfa1*x
           translate    A1*x

           rotate      Fi1*z
           translate    D1*z
           rotate    Alfa0*x
           translate    A0*x


       }


#declare Px =-1.2011115;
#declare Py = 0.3-0.5;
#declare Pz = 0.0;

  sphere { <Px, Py, Pz>, 0.3 texture { Copper_Metal }

         }



/*}}}*/

// END
